vs.2.0

dcl_position  v0
dcl_texcoord0 v1

def		c5,		1.0, 2.0, 0.0, 0.002

// Transform position
m4x4	oPos, v0, c0

// Output texcoord
mov		oT0, v1


// Fog depth sum
mov		r9,  c5.z
// Lighting sum
mov		r10, c5.z

loop	aL, i0

	sub		r0, v0, c4              // r0 = v1 - v0
	mov		r1, c[aL]               // r1 = v2
	sub		r1, r1, c4              // r1 = v2 - v0

	dp3		r2, r0, r1              // r2 = (v1 - v0) * (v2 - v0)
	dp3		r3, r0, r0	     	    // r3 = lengthSqr(v1 - v0)
	rcp		r3, r3.x                // r3 = 1 / lengthSqr(v1 - v0)

	mul		r2, r2, r3              // r2 = t = (v1 - v0) * (v2 - v0) / lengthSqr(v1 - v0)
	mad		r3, r0, r2, c4          // r3 = v3 = v0 + (v1 - v0) * t

	sub		r0, r3, c[aL]           // r0 = v3 - v2
	dp3		r0, r0, r0              // r0 = lengthSqr(v3 - v2)
	dp3		r1, r1, r1              // r1 = lengthSqr(v2 - v0)

	sub		r6,   c[aL].w, r0       // r6 = r * r - lengthSqr(v3 - v2)
	rsq		r6.w, r6.x
	mul		r6,   r6, r6.w          // r6 = sqrtf(r * r - lengthSqr(v3 - v2))

	sub		r4,   v0, r3            // r4 = v1 - v3
	dp3		r4,   r4, r4            // r4 = lengthSqr(v1 - v3)
	rsq		r4.w, r4.w
	mul		r4,   r4, r4.w          // r4 = dist(v1, v3)

	slt		r7.x, r2.x, c5.x        // r7.x = t < 1
	mad		r5.x, r7.x, c5.y, -c5.x // r5.x = sign(t-1)
	mad		r5, r5.x, r4, r6        // r5 = sqrtf(r * r - lengthSqr(v3 - v2)) +/- dist(v1, v3)

	sge		r7.y, r2.x, c5.z        // r7.y = t > 0
	mul		r7.x, r7.x, r7.y        // r7.x = t > 0 && t < 1
	mul		r7.x, r7.x, c5.y        // r7.x = 2 * (t > 0 && t < 1)

	sub		r2,   v0, c[aL]         // r2 = v1 - v2
	dp3		r2,   r2, r2            // r2 = lengthSqr(v1 - v2)

	// Lighting
	rsq		r2.w, r2.w
	mad		r10, c[aL].w, r2.w, r10


	sge		r7.z, r2.x, c[aL].w     // r7.z = lengthSqr(v1 - v2) > r * r
	slt		r7.w, r2.x, c[aL].w     // r7.w = lengthSqr(v1 - v2) < r * r
	mul		r8, r7.x, r6
	mul		r8, r8, r7.z
	mad		r8, r7.w, r5, r8        // if (lengthSqr(v0 - v2) > r * r) .... done



	sub		r4,   c4, r3            // r4 = v0 - v3
	dp3		r4,   r4, r4            // r4 = lengthSqr(v0 - v3)
	rsq		r4.w, r4.w
	mul		r4,   r4, r4.w          // r4 = dist(v0, v3)

	sub		r5,   c4, v0            // r5 = v0 - v1
	dp3		r5,   r5, r5            // r5 = lengthSqr(v0 - v1)
	rsq		r5.w, r5.w
	mul		r5,   r5, r5.w          // r5 = dist(v0, v1)

	mad		r7.y, r7.y, c5.y, -c5.x // r7.y = sign(t)
	mad		r6, r4, r7.y, r6        // r6 = sqrtf(r * r - lengthSqr(v3 - v2)) +/- dist(v0, v3)

	mul		r6, r7.z, r6
	mad		r6, r7.w, r5, r6

	sge		r1.x, r1.x, c[aL].w
	slt		r1.y, r1.y, c[aL].w

	mul		r8, r1.x, r8
	mad		r8, r1.y, r6, r8

	slt		r0, r0, c[aL].w
	mad		r9, r8, r0, r9

endloop

mul		r9, r9, c5.w
mul		r9, r9, r9

mul		r10, r10, c5.w

mov		oT1, r9
mov		oT2, r10
